//#define __NO_VERSION__		// ??? 2.6 ??? 2.4 ???

//#include <linux/version.h>
//#undef KERN_2_6
//#if(LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0))
//#define KERN_2_6 1
//#endif

//#ifndef KERN_2_6
//#if CONFIG_MODVERSIONS==1		// 2.4 ???
//#include <linux/modversions.h>
//#endif
//#endif

//#include <linux/config.h>
#include <linux/module.h>

#include <linux/signal.h>
#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/time.h>
#include <asm/irq.h>

#include <mcua.h>
#include "rs485.h"

#ifdef __CP132__
	#include <moxa132.h>
#endif
#ifdef __CP102__
	#include <moxa102.h>
#endif
#ifdef __COM__
	#include <com.h>
#endif
#ifdef __LPT__
	#include <lpt.h>
#endif

extern inline void receiv_data(RS485INFO *info);
extern inline int rs485_get_port(int irq);
extern RS485INFO *info_port1, *info_port2;
extern int irq1, irq2;

static struct timeval start_waiting;

/*
int iround(float a) {
	int i;
	if(a >= INT_MAX) return(INT_MAX);
	if(a <= INT_MIN) return(INT_MIN);
	i = (int) a;
	if(a < (float)i + 0.5) return i;
	return(i+1); 
}
*/

inline void rs485_gettime(rs485_time_t *tm) {
	do_gettimeofday(tm);
	return;
}

inline void rs485_printtime(rs485_time_t *tm) {
	RS_PRINT( "rs485-time> %ld s %ld usec\n",
						tm->tv_sec, tm->tv_usec );
	return;
}

inline void rs485_printtm_interval(rs485_time_t *tm_start,
										rs485_time_t *tm_end) {
	RS_PRINT( "rs485-dtime> %ld usec\n",
					(tm_end->tv_sec - tm_start->tv_sec)*1000000L+
					(tm_end->tv_usec - tm_start->tv_usec) );
	return;
}

inline void rs485_set_starttime(void) {
	do_gettimeofday( &start_waiting );
}

inline int rs485_timeout(long interval) {	// usec
	struct timeval tv;
	long usec;

	do_gettimeofday(&tv);
/* */
	usec = (tv.tv_sec-start_waiting.tv_sec)*1000000L
					 + (tv.tv_usec-start_waiting.tv_usec);
/*	
	PDEBUGG( "%ld : %ld - %ld : %ld => dusec=%ld\n",
				tv.tv_sec,
				tv.tv_usec,
				start->tv_sec,
				start->tv_usec,
				usec );
*/
//	if( ( (tv.tv_sec - start_waiting.tv_sec)*1000000L
//					 + (tv.tv_usec - start_waiting.tv_usec) )
	if( usec > interval ) {
		PDEBUGG( "Timeout!!!\n" );
		PDEBUG( "tmout=%ld usec\n",usec );
		return 1;
	} else return 0;
}

//    
#ifndef KERN_2_6
static void rs485_interrupt(int irq, void *dev_id, struct pt_regs *regs) {
#else
static irqreturn_t rs485_interrupt(int irq, void *dev_id, struct pt_regs *regs) {
#endif
	RS485INFO *info_port = info_port1;
	int res;

	res = rs485_get_port(irq);

	if(res == 1) info_port = info_port1;
	else if(res == 2) info_port = info_port2;
	else {
		PDEBUG("rs485_tools: empty interrupt!\n");
#ifndef KERN_2_6
		return;
#else
		return IRQ_NONE;
#endif
	}
	receiv_data(info_port);
#ifndef KERN_2_6
	return;
#else
	return IRQ_HANDLED;
#endif
}

static int dev_id = 1;
int rs485_request_irq(unsigned int irq) {
	int err=0;
#ifndef KERN_2_6
	unsigned long flags;
	save_flags(flags); cli();
#endif
// SA_SHIRQ - PCI trebuet shared irq (2.6 -tochno, 2.4 - ne znayu)
	if( (err=request_irq(irq, rs485_interrupt,
				SA_INTERRUPT 
#ifdef __PCI__
				| SA_SHIRQ
#endif
				, ADAPTER_ID,
				&dev_id)) != 0 ) {
		RS_PRINT(KERN_CRIT "rs485: request irq %d failed\n",irq);
	}
#ifndef KERN_2_6
	sti(); restore_flags(flags);
#endif
	return err;
}

void rs485_clean_irq(unsigned int irq) {
#ifndef KERN_2_6	
	unsigned long flags;
	save_flags(flags); cli();
	free_irq(irq, &dev_id);
	sti(); restore_flags(flags);
#else
	free_irq(irq, &dev_id);
#endif
}

static unsigned long flags;
static int is_flags_saved = 0;

#ifndef KERN_2_6
inline void rs485_stop_interrupts(void) {
// disable all interrupts
	save_flags(flags);
	is_flags_saved = 1;
	cli();
}

inline void rs485_allow_interrupts(void) {
// enable interrupts
	sti();
	if(is_flags_saved) restore_flags(flags);
}
#else
inline void rs485_stop_interrupts(void) {
	is_flags_saved = 1;
	local_irq_save(flags);
}

inline void rs485_allow_interrupts(void) {
	if(is_flags_saved) local_irq_restore(flags);
}
#endif
